{"openapi":"3.0.0","info":{"version":"4.3.4","title":"TechPort","description":"TechPort RESTful API","contact":{"name":"TechPort Team","email":"hq-techport@mail.nasa.gov","url":"https://techport.nasa.gov"}},"servers":[{"url":"https://techport.nasa.gov"}],"paths":{"/api":{"get":{"description":"Returns the swagger specification for the API.","responses":{"200":{"description":"Successful response"},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/contacts":{"get":{"description":"Returns a list of contacts in TechPort.","parameters":[{"name":"filter","in":"query","description":"Contacts returned will have either first name, last name, or email that matches the filter. If no filter is passed, no contacts will be returned.","required":true,"schema":{"type":"string"}}],"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"contacts":{"type":"array","items":{"$ref":"#/components/schemas/contact"}}}}}}},"default":{"description":"Object not found."}}}},"/api/contacts/{contactId}":{"get":{"description":"Get a contact based on id.","parameters":[{"name":"contactId","in":"path","description":"Contact id to pull.","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Success contact.","content":{"application/json":{"schema":{"type":"object","properties":{"contact":{"$ref":"#/components/schemas/contact"}}}}}},"default":{"description":"Error."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/enums":{"get":{"description":"Returns the enumerations of various fields.","responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"enums":{"$ref":"#/components/schemas/enums"}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/enums/{enumName}":{"get":{"description":"Returns the enumerations of various fields for a given enum name.","parameters":[{"name":"enumName","in":"path","description":"Name of the enum to fetch.","required":true,"schema":{"type":"string","format":"binary"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"enums":{"$ref":"#/components/schemas/enums"}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/feedback":{"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Submits feedback.","requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["feedback"],"properties":{"feedback":{"$ref":"#/components/schemas/feedback"}}}}}},"responses":{"200":{"description":"Successful feedback submission"},"default":{"description":"Object not found."}}}},"/api/nonce":{"get":{"description":"Refreshes the users nonce.","responses":{"200":{"description":"The new nonce"},"default":{"description":"Unauthorized."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/{objectType}/schema":{"get":{"description":"Returns the object schema of a strategic outcome.","parameters":[{"name":"objectType","in":"path","description":"The object type string.","required":true,"schema":{"$ref":"#/components/schemas/objectType"}},{"name":"startFundingYear","in":"query","description":"The starting fiscal year.","schema":{"type":"integer"}},{"name":"endFundingYear","in":"query","description":"The ending fiscal year.","schema":{"type":"integer"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/schema"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/{objectType}/search":{"get":{"description":"Searches on the given object type.","parameters":[{"name":"objectType","in":"path","description":"The object type string.","required":true,"schema":{"$ref":"#/components/schemas/objectType"}},{"name":"query","in":"query","description":"The search query string.","schema":{"type":"string"}}],"responses":{"200":{"description":"Successful search.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/searchResult"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Searches on the given object type based on the passed in criteria.","parameters":[{"name":"objectType","in":"path","description":"The object type string.","required":true,"schema":{"$ref":"#/components/schemas/objectType"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/searchCriteria"}}}},"responses":{"200":{"description":"Successful search.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/searchResult"}}}},"default":{"description":"Object not found."}}}},"/api/{objectType}/search/allData":{"get":{"description":"Conducts a search for all projects with all fields included.","parameters":[{"name":"objectType","in":"path","description":"The object type string.","required":true,"schema":{"$ref":"#/components/schemas/objectType"}}],"responses":{"200":{"description":"Successful search.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/searchResult"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/opportunities":{"get":{"description":"Returns a list of all opportunities.","responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"opportunities":{"type":"array","items":{"$ref":"#/components/schemas/opportunity"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Returns a list of opportunities based on passed in criteria.","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/opportunityCriteria"}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"opportunities":{"type":"array","items":{"$ref":"#/components/schemas/opportunity"}}}}}}},"default":{"description":"Object not found."}}}},"/api/opportunities/{opportunityId}":{"get":{"description":"Returns the data for a specific opportunity.","parameters":[{"name":"opportunityId","in":"path","description":"ID of opportunity to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"opportunity":{"$ref":"#/components/schemas/opportunity"}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/opportunities/export":{"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Returns a file containing funding opportunities information in XLSX format.","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/opportunityCriteria"}}}},"responses":{"200":{"description":"Successful response","content":{"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":{"schema":{"type":"string","format":"binary"}}}},"default":{"description":"Object not found."}}}},"/api/opportunities/maxFundingAmount":{"get":{"description":"Returns the max funding amount.","responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"maxFunding":{"type":"integer","format":"int64"}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/organizations":{"get":{"description":"Returns a list of organizations that match the given filters.","parameters":[{"name":"organizationName","in":"query","description":"Organization Name to filter on.","required":false,"schema":{"type":"string"}},{"name":"organizationAcronym","in":"query","description":"Organization Acronym to filter on.","required":false,"schema":{"type":"string"}},{"name":"organizationUei","in":"query","description":"Organization UEI to filter on.","required":false,"schema":{"type":"string"}},{"name":"organizationCageCode","in":"query","description":"Organization Cage Code to filter on.","required":false,"schema":{"type":"string"}},{"name":"searchOrganizationTypes","in":"query","description":"List of Organization Types to filter on.","required":false,"schema":{"type":"array","items":{"type":"string","enum":["NASA Other","NASA Mission Directorate","NASA Center","NASA Facility","NASA Office","NASA Program","NASA Mission","FFRDC/UARC","Other US Government","Industry","Academia","International Space Agency","Non-Profit Institution","N/A"]}}},{"name":"limit","in":"query","description":"Limit of organization results to return, if null then all organization results will be returned.","required":false,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"organizations":{"type":"array","items":{"$ref":"#/components/schemas/organization"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/organizations/{organizationId}":{"get":{"description":"Get an organization and its information.","parameters":[{"name":"organizationId","in":"path","description":"Organization Id.","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Success. Organization detailed data.","content":{"application/json":{"schema":{"type":"object","properties":{"organization":{"$ref":"#/components/schemas/organization"}}}}}},"default":{"description":"Error."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/organizations/types":{"get":{"description":"Returns a list of available organization types, including set-aside and MSI types.","responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"organizations":{"type":"array","items":{"$ref":"#/components/schemas/organizationType"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/organizations/searchOrgs":{"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Returns a list of organizations that match the given filters.","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"organizationName":{"description":"Organization Name to filter on.","type":"string"},"organizationAcronym":{"description":"Organization Acronym to filter on.","type":"string"},"organizationUei":{"description":"Organization UEI to filter on.","type":"string"},"organizationCageCode":{"description":"Organization Cage Code to filter on.","type":"string"},"searchOrganizationTypes":{"description":"List of Organization Types to filter on.","type":"array","items":{"type":"string","enum":["NASA Other","NASA Mission Directorate","NASA Center","NASA Facility","NASA Office","NASA Program","NASA Mission","FFRDC/UARC","Other US Government","Industry","Academia","International Space Agency","Non-Profit Institution","N/A"]}},"limit":{"description":"Limit of organization results to return, if null then all organization results will be returned.","type":"integer"}}}}}},"responses":{"200":{"description":"The list of organizations that match the filters.","content":{"application/json":{"schema":{"type":"object","properties":{"organizations":{"type":"array","items":{"$ref":"#/components/schemas/organization"}}}}}}},"default":{"description":"Object not found."}}}},"/api/programs":{"get":{"description":"Returns a list of all programs.","parameters":[{"name":"activeOnly","in":"query","description":"Retrieve only active programs.","required":false,"schema":{"type":"boolean"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"programs":{"type":"array","items":{"$ref":"#/components/schemas/program"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/programs/{programId}":{"get":{"description":"Get a program and its information.","parameters":[{"name":"programId","in":"path","description":"Program Id.","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Success. Program detailed data.","content":{"application/json":{"schema":{"type":"object","properties":{"program":{"$ref":"#/components/schemas/program"}}}}}},"default":{"description":"Error."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/projects":{"get":{"description":"Returns a list of available technology project IDs.","parameters":[{"name":"updatedSince","in":"query","description":"ISO 8601 full-date in the format YYYY-MM-DD. Filters the list of available ID values by their lastUpdated parameter.","required":true,"schema":{"type":"string","format":"date"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"projectId":{"type":"integer","format":"int64"},"lastUpdated":{"type":"string"}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/projects/{projectId}":{"get":{"description":"Returns information about a specific technology project.","parameters":[{"name":"projectId","in":"path","description":"ID of project to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/project"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/searches/{searchId}":{"get":{"description":"Runs a saved search using the provided search Id.","parameters":[{"name":"searchId","in":"path","description":"ID of saved search to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/userSearch"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies":{"get":{"description":"Returns a list of taxonomy roots in TechPort.","responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"taxonomyRoots":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyRoot"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/{taxonomyRootId}":{"get":{"description":"Returns a taxonomy root and its children based on taxonomyRootId.","parameters":[{"name":"taxonomyRootId","in":"path","description":"ID of taxonomy root to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"taxonomyRoot":{"$ref":"#/components/schemas/taxonomyRoot"},"children":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyNode"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/{taxonomyRootId}/search":{"get":{"description":"Conducts a search on taxonomy nodes within a taxonomy root based on the query provided","parameters":[{"name":"query","in":"query","description":"A query to match on in taxonomy nodes.","required":true,"schema":{"type":"string","format":"binary"}},{"name":"taxonomyRootId","in":"path","description":"The taxonomy root ID value to search on.","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"results":{"type":"object","properties":{"results":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyNode"}}}},"taxonomyResults":{"type":"object","properties":{"children":{"type":"array","items":{"$ref":"#/components/schemas/treeNode"}}}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/{taxonomyRootId}/excel":{"get":{"description":"Returns a file containing taxonomies information in XLSX format.","parameters":[{"name":"taxonomyRootId","in":"path","description":"ID of taxonomy root to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response","content":{"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":{"schema":{"type":"string","format":"binary"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/{taxonomyRootId}/word":{"get":{"description":"Returns a file containing taxonomies information in DOCX format.","parameters":[{"name":"taxonomyRootId","in":"path","description":"ID of taxonomy root to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response","content":{"application/vnd.openxmlformats-officedocument.wordprocessingml.document":{"schema":{"type":"string","format":"binary"}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/nodes":{"get":{"description":"Returns a list of all taxonomy nodes for a given root ID in TechPort.","parameters":[{"name":"rootId","in":"query","description":"The root ID of the taxonomy nodes to pull. If no root ID is passed, no nodes will be returned.","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"level","in":"query","description":"The level of taxonomy node to fetch.","required":false,"schema":{"type":"integer","format":"int64"}},{"name":"code","in":"query","description":"A code representation of the nodes to fetch","required":false,"schema":{"type":"string","format":"binary"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"taxonomyNodes":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyNode"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/nodes/{taxonomyNodeId}":{"get":{"description":"Returns a taxonomy node and its children based on taxonomyNodeId.","parameters":[{"name":"taxonomyNodeId","in":"path","description":"ID of taxonomy node to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"taxonomyNode":{"$ref":"#/components/schemas/taxonomyNode"},"children":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyNode"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/nodes/{taxonomyNodeId}/all":{"get":{"description":"Returns a taxonomy node and all of its children and grandchildren based on the taxonomyNodeId.","parameters":[{"name":"taxonomyNodeId","in":"path","description":"ID of taxonomy node to fetch","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"taxonomyNode":{"$ref":"#/components/schemas/taxonomyNode"},"children":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyNode"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/taxonomies/nodes/{rootId}/tree":{"get":{"description":"Returns a full taxonomy in a tree format.","parameters":[{"name":"rootId","in":"path","description":"Root ID of taxonomy to fetch the tree for","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"taxonomyTree":{"type":"array","items":{"$ref":"#/components/schemas/taxonomyNode"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/trex/predict":{"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Retrieves taxonomy recommendations for the provided technology description.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","minProperties":1,"properties":{"title":{"type":"string","description":"Title of the technology."},"description":{"type":"string","description":"Description of the technology."},"ta":{"type":"string","description":"Prior 2015 NASA Technology Taxonomy (TA) classification. See example for expected format.","example":"TA5.4.6"},"threshold":{"type":"integer","format":"int64","description":"Score threshold of recommendations to return."},"topn":{"type":"integer","format":"int64","description":"Top number (limit) of recommendations to return."}}},"example":{"title":"Guided Parafoil High Altitude Research","description":"Airborne Systems provides parachute recovery systems for space","benefits":"The guided parafoil system will allow for a precision recovery of spent boosters and recovery/landing of reusable launch vehicles.  This will benefit the commercial space industry ","ta":"TA9.2.2","topn":6}}}},"responses":{"200":{"description":"Successful response. Returns the JSON-formatted TX class number with, if topn or threshold specified, a recommendation score, in best-first order.  If topn or threshold is not specified in input request body, the top recommendation is returned.","content":{"application/json":{"schema":{"type":"object","additionalProperties":true},"example":{"9.2.1":0.45576102935870416,"13.4.4":0.003116953736313801,"9.4.6":0.0026820951301047926,"16.5":0.0019523943067510823,"10.2.5":0.0019401367001082358,"9.4.7":0.001872107302461415}}}},"default":{"description":"Missing authentication key."}}}},"/drex/predict":{"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"post":{"description":"Retrieves Destination Area recommendations for the provided project description.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","minProperties":1,"properties":{"title":{"type":"string","description":"Project Title."},"program_acronym":{"type":"string","description":"Short NASA Program Acronym, e.g. NIAC, ESD, etc."},"description":{"type":"string","description":"Project Description."},"benefits":{"type":"string","description":"Benefits of the project"},"closeout":{"type":"string","description":"Closeout notes of a project"},"threshold":{"type":"integer","format":"int64","description":"Score threshold of recommendations to return."}}},"example":{"title":"Variable Vector Countermeasure Suit for Space Habitation and Exploration","program_acronym":"NIAC","description":"variable vector countermeasure suit v2suit specialized spacesuit designed keep astronauts healthy long duration space exploration missions","closeout":""}}}},"responses":{"200":{"description":"Successful response. Returns JSON-formatted string with recommendation score, in best first order. If threshold is not specified in input data, the best destinations with 98.9% accuracy are returned","content":{"application/json":{"schema":{"type":"object","additionalProperties":true},"example":{"The Moon":0.37870039721850457,"Mars":0.307858003568415,"Earth":0.28895379252656955}}}},"default":{"description":"Missing authentication key."}}}},"/api/strategy":{"get":{"description":"Returns the strategy data.","responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"shortfalls":{"type":"array","items":{"$ref":"#/components/schemas/shortfall"}},"capabilities":{"type":"array","items":{"$ref":"#/components/schemas/capability"}},"strategyDownloadId":{"type":"integer","format":"int64"}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}},"/api/strategy/shortfalls/search":{"get":{"description":"Searches the strategy shortfall data.","parameters":[{"name":"query","in":"path","description":"Search query for shortfalls","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Successful response.","content":{"application/json":{"schema":{"type":"object","properties":{"shortfalls":{"type":"array","items":{"$ref":"#/components/schemas/shortfall"}}}}}}},"default":{"description":"Object not found."}}},"head":{"description":"Returns a metadata in the form of response headers.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}},"options":{"description":"Returns a list of valid request types for this endpoint.","responses":{"200":{"description":"Successful response","content":{"application/json":{}}},"default":{"description":"Object not found."}}}}},"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"capability":{"type":"object","description":"Represents a capability.","properties":{"capabilityId":{"type":"integer","format":"int64","description":"Unique identifier for the capability."},"title":{"type":"string","description":"Title of the capability."},"description":{"type":"string","description":"Description of the capability."},"domain":{"type":"string","description":"Name of the domain / grouping this capability is associated with."}}},"contact":{"type":"object","description":"Represents an individual and their details.","properties":{"contactId":{"type":"integer","format":"int64","description":"Unique ID for this contact"},"canUserEdit":{"type":"boolean","description":"Whether or not the user can edit."},"firstName":{"type":"string","description":"Contact first name.","x-uiGrid-Exclude":true},"lastName":{"type":"string","description":"Contact last name.","x-uiGrid-Exclude":true},"fullName":{"type":"string","description":"Contact full name.","x-uiName":"Name"},"fullNameInverted":{"type":"string","description":"Contact full name inverted."},"middleInitial":{"type":"string","description":"Contact middle initial.","x-uiGrid-Exclude":true},"email":{"type":"string","description":"Contact e-mail address.","x-uiName":"Email"},"phone":{"type":"string","description":"Contact phone number.","x-uiName":"Phone"},"receiveEmail":{"type":"string","description":"Enum for email subscription types.","enum":["Unsubscribed","Subscribed User","Subscribed Contact"]}}},"country":{"type":"object","description":"Represents a country location.","properties":{"countryId":{"type":"integer","format":"int64","description":"Unique ID for the country"},"abbreviation":{"type":"string","description":"Abbreviation that can be used for the country."},"name":{"type":"string","description":"Name that can be used for the country."}}},"enums":{"type":"object","description":"An object containing entries for each enum type.","$ref":"#/components/schemas/enum"},"feedback":{"type":"object","description":"A representation of feedback.","properties":{"question":{"type":"string","description":"The feedback question.."},"response":{"type":"object","description":"The feedback response. Specific structure depends on the feedback question."}}},"file":{"type":"object","description":"Represents a file associated with a library item.","properties":{"fileId":{"type":"integer","format":"int64","description":"Unique identifier for the file."},"url":{"type":"string","description":"The TechPort URL at which the file is accessible for download."},"fileSize":{"type":"integer","format":"int64","description":"The size of the file in bytes."},"fileExtension":{"type":"string","description":"The file extension for the file."},"fileName":{"type":"string","description":"The file name."}}},"flexField":{"type":"object","description":"A description of a flex field JSON object properties. A flex field is an additional field for a project object that may change over time and is defined in JSON format.","properties":{"flexFieldId":{"type":"integer","format":"int64","description":"Unique id for this flex field."},"fieldName":{"type":"string","description":"The exact flex field key that will be present in a project object."},"fieldType":{"type":"string","enum":["integer","boolean","string","array_string","array_string_single","rich_text","date"],"description":"Custom field type describing json content."},"programId":{"type":"integer","format":"int64","description":"If this flex field is unique to projects within a certain program, this references the program identifier."},"uiName":{"type":"string","description":"A user-interface-friendly name for the field."},"options":{"type":"array","items":{"type":"string"},"description":"The list of options that a flex field can utilize."}}},"libraryItem":{"type":"object","description":"Represents a specific library item.","properties":{"libraryItemId":{"type":"integer","format":"int64","description":"Unique identifier for the library item."},"projectId":{"type":"integer","format":"int64","description":"Unique identifier for the project that houses the library item."},"title":{"type":"string","description":"Title of the library item","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Library Item Title"},"libraryItemType":{"type":"string","enum":["Link","Story","Video","Image","Document","STI DAA","Data Set"],"description":"Identifies the type of library item, e.g. Image.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Library Item Type"},"files":{"type":"array","description":"List of files associated with the library item.","items":{"$ref":"#/components/schemas/file"}},"description":{"type":"string","description":"Description of the library item.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Description/Caption"},"url":{"type":"string","description":"External URL for the library item.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"URL"},"publishedDate":{"type":"string","description":"Date the library item was published.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Published Date","x-uiExcelType":"DATE"},"publishedDateString":{"type":"string","description":"Date the library item was published."},"publishedBy":{"type":"string","description":"Publisher of the library item.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Published By"},"file":{"$ref":"#/components/schemas/file","description":"File associated with the library item."},"fileId":{"type":"integer","format":"int64","description":"File ID associated with the library item, returned with the SOLR search.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"File Download","x-uiExcelType":"FILE-ID"}}},"libraryItemsPreFilter":{"type":"object","description":"The pre filter built for Library Items filtering.","properties":{"filter":{"type":"string","description":"The string to filter on"},"types":{"type":"array","items":{"type":"object","properties":{"type":{"type":"string","description":"The library item type to filter on"}}},"description":"A list of objects representing what Library Item types should be filtered on."}}},"myTechPortEntry":{"type":"object","description":"My TechPort preferences","properties":{"defaultHomeView":{"type":"string","description":"The default home view (currently 'home', 'grid', 'list', 'reports')."},"systemNotifications":{"type":"object","description":"Settings for My TechPort's system notifications.","$ref":"#/components/schemas/mySystemNotifications"},"workflowNotifications":{"type":"object","description":"Settings for My TechPort's workflow notifications.","$ref":"#/components/schemas/myWorkflowNotifications"}}},"mySystemNotifications":{"type":"object","description":"My TechPort system notification preferences.","properties":{"receiveGeneralEmails":{"type":"boolean","description":"Whether the user wants to receive general TechPort notices."},"receiveUrgentEmails":{"type":"boolean","description":"Whether the user wants to receive urgent TechPort notices. Currently required."}}},"myWorkflowNotifications":{"type":"object","description":"My TechPort workflow notification preferences.","properties":{"receiveReleasedEmails":{"type":"boolean","description":"Whether the user wants to be notified when their data is released."},"receiveRevertedEmails":{"type":"boolean","description":"Whether the user wants to be notified when their data is reverted to draft."},"receiveSubmittedEmails":{"type":"boolean","description":"Whether the user wants to be notified when their data is submitted for review."}}},"objectType":{"type":"string","description":"Types of objects in the system that are searchable.","enum":["projects","taxonomies","organizations"]},"opportunity":{"type":"object","description":"Represents a funding opportunity.","properties":{"opportunityId":{"type":"integer","format":"int64","description":"The ID of the funding opportunity."},"name":{"type":"string","description":"The name of the funding opportunity."},"description":{"type":"string","description":"The description for the funding opportunity."},"duration":{"type":"integer","format":"int64","description":"The average duration of the opportunity."},"amount":{"type":"integer","format":"int64","description":"The average funding opportunity amount."},"url":{"type":"string","description":"The url link for the funding opportunity."},"frequency":{"type":"string","description":"The funding opportunity frequency."},"nextSolicitation":{"type":"string","description":"The next solicitation for the funding opportunity."},"responsibleMdOffice":{"type":"integer","format":"int64","description":"The mission directorate ID for the funding opportunity."},"directorate":{"type":"object","description":"The mission directorate for the funding opportunity.","$ref":"#/components/schemas/organization"},"topicBased":{"type":"string","description":"The topic of the funding opportunity.","enum":["Topic","Open","Other"]},"role":{"type":"array","items":{"type":"string","enum":["General Public / Innovator","Small Business","Large Business","Non-Profit or Research Institution","International","NASA","Undergraduate Student","Graduate Student","High School Student","Other Academic Researcher","Minority-Serving Institution","Middle School Student"]},"description":"The supported roles of the funding opportunity."},"trlValues":{"type":"array","items":{"type":"integer","format":"int64"},"description":"The supported TRLs of the funding opportunity."}}},"opportunityCriteria":{"type":"object","description":"Represents a funding opportunity criteria.","properties":{"roles":{"type":"array","items":{"type":"string","enum":["General Public / Innovator","Small Business","Large Business","Non-Profit or Research Institution","International","NASA","Undergraduate Student","Graduate Student","High School Student","Other Academic Researcher","Minority-Serving Institution","Middle School Student"]},"description":"The supported roles of the funding opportunity criteria."},"minFunding":{"type":"integer","format":"int64","description":"The minimum funding for the funding opportunity criteria."},"maxFunding":{"type":"integer","format":"int64","description":"The maximum funding for the funding opportunity criteria."},"minTrl":{"type":"integer","format":"int64","description":"The minimum TRL for the funding opportunity criteria."},"maxTrl":{"type":"integer","format":"int64","description":"The maximum TRL for the funding opportunity criteria."},"directorate":{"type":"string","description":"The directorate of the funding opportunity criteria."}}},"organization":{"type":"object","description":"Represents an organization object","properties":{"organizationId":{"type":"integer","format":"int64","description":"Unique ID for the organization"},"organizationName":{"type":"string","description":"Name that represents the organization","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Organization Name"},"acronym":{"type":"string","description":"Acronym that represents the organization","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Acronym"},"organizationRole":{"type":"string","enum":["Lead Organization","Supporting Organization","Cofunding Partner"],"description":"Role of the organization within a project.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Organization Role"},"organizationType":{"type":"string","enum":["NASA Other","NASA Mission Directorate","NASA Center","NASA Facility","NASA Office","NASA Program","NASA Mission","FFRDC/UARC","Other US Government","Industry","Academia","International Space Agency","Non-Profit Institution","N/A"],"description":"Type of organization.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Organization Type"},"city":{"type":"string","description":"City where the organization is located"},"stateTerritoryId":{"type":"integer","format":"int64","description":"Unique ID for the state/territory where the organization is located"},"stateTerritory":{"$ref":"#/components/schemas/stateTerritory","description":"The state/territory object."},"stateAbbreviation":{"type":"string","description":"The state abbreviation."},"stateName":{"type":"string","description":"The state name."},"countryId":{"type":"integer","format":"int64","description":"Unique ID for the country where the organization is located"},"country":{"$ref":"#/components/schemas/country","description":"The country object."},"countryAbbreviation":{"type":"string","description":"The country abbreviation."},"countryName":{"type":"string","description":"The country name."},"zipCode":{"type":"string","description":"Zip code where the organization is located"},"murepUnitId":{"type":"integer","format":"int64","description":"Unique identifier assigned to U.S. academic institutions by MUREP."},"academicDegreeType":{"type":"string","enum":["Public 2 year","Public 4 year","Private 2 year","Private 4 year","Unknown"],"description":"Type of Academic Degree (if any) the organization supports."},"uei":{"type":"string","description":"The unique entity identifier (UEI) of the entity."},"dunsNumber":{"type":"string","description":"The DUNS number assigned to the organization."},"deia":{"description":"A key/value pair of strings describing the organization MSI status by fiscal year.","type":"object","additionalProperties":{"type":"array","description":"The organization MSI status types for a given fiscal year.","items":{"type":"string"}}},"cageCode":{"type":"string","description":"The cage code of the organization"},"congressionalDistrict":{"type":"string","description":"The congressional district of the organization"}}},"organizationsPreFilter":{"type":"object","description":"The pre filter built for Organization filtering.","properties":{"filter":{"type":"string","description":"The string to filter on"},"types":{"type":"array","items":{"type":"object","properties":{"type":{"type":"string","description":"The organization type to filter on"}}},"description":"A list of objects representing what Organization types should be filtered on."}}},"organizationType":{"type":"object","description":"A heirarchical representation of an organization type. Similar to the LkuCode type returned for organization.organizationType, but formatted in a parent/child relationship.","properties":{"organizationTypeId":{"type":"integer","format":"int64","description":"Unique ID for this organization type."},"name":{"type":"string","description":"The name of the organization type."},"hasChildren":{"type":"boolean","description":"Whether or not the type has child types."},"level":{"type":"string","description":"The relative level of the organization type in the heirarchy."},"parentId":{"type":"integer","format":"int64","description":"Unique ID for the parent type in the heriarchy."}}},"preFilters":{"type":"object","description":"The pre filters to be run before performing the SOLR query. Produce a list of project IDs to filter on.","properties":{"libraryItemsFilter":{"$ref":"#/components/schemas/libraryItemsPreFilter","description":"A pre filter built for filtering on library items"},"organizationsFilter":{"$ref":"#/components/schemas/organizationsPreFilter","description":"A pre filter built for filtering on organizations"},"technologyOutcomesFilter":{"$ref":"#/components/schemas/technologyOutcomesPreFilter","description":"A pre filter built for filtering on technology outcomes"}}},"program":{"type":"object","description":"Represents a NASA program.","properties":{"programId":{"type":"integer","format":"int64","description":"Unique ID for this program"},"ableToSelect":{"type":"boolean","description":"Able to select program for assignment."},"acronym":{"type":"string","description":"Acronym for this program"},"active":{"type":"boolean","description":"True if the program is still active"},"description":{"type":"string","description":"Description for the program"},"parentProgram":{"$ref":"#/components/schemas/program","description":"Program object representing the parent program"},"parentProgramId":{"type":"integer","format":"int64","description":"Unique ID for the parent program"},"responsibleMd":{"$ref":"#/components/schemas/organization","description":"Responsible Mission Directorate for this program"},"responsibleMdId":{"type":"integer","format":"int64","description":"Unique ID for the parent responsible mission directorate"},"title":{"type":"string","description":"Title for the program"}}},"programContact":{"type":"object","description":"Represents a contact that is linked to a program.","properties":{"contactId":{"type":"integer","format":"int64","description":"Unique ID for the contact"},"programId":{"type":"integer","format":"int64","description":"Unique ID for the program"},"programContactType":{"type":"string","enum":["Program Director","Program Manager","Program Executive"],"description":"Role of the contact in relation to the program."},"contact":{"$ref":"#/components/schemas/contact","description":"The contact object."}}},"project":{"type":"object","description":"Top-level TechPort object representing a NASA technology project and its associated data.","properties":{"projectId":{"type":"integer","format":"int64","description":"Unique identifier for the project.","x-uiExcelHeaderName":"Project ID","x-uiExcelId":true,"x-uiExcelWorksheet":"Projects","x-uiFieldGroup":"Identification","x-uiFilterType":"text","x-uiGrid-CanHide":false,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderProjectId","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":70,"x-uiGrid-CellWidth":70,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Project ID"},"title":{"type":"string","description":"Title of the project.","maxLength":200,"x-uiExcelHeaderName":"Title","x-uiExcelWorksheet":"Projects","x-uiFieldGroup":"Project","x-uiFilterType":"text","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderProjectTitle","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Title"},"acronym":{"type":"string","description":"Abbreviated name of the project.","maxLength":200,"x-uiExcelHeaderName":"Acronym","x-uiExcelWorksheet":"Projects","x-uiFieldGroup":"Project","x-uiFilterType":"text","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"simple","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":70,"x-uiGrid-CellWidth":70,"x-uiGrid-DefaultField":true,"x-uiName":"Acronym","x-uiIncludeInExcel":true,"x-uiWorksheet":"Projects"},"status":{"type":"string","enum":["Active","Inactive"],"description":"Status of the project.","x-uiFieldGroup":"Project","x-uiFilterType":"checkbox","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"simple","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":100,"x-uiGrid-CellWidth":100,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Status","x-uiExcelHeaderName":"Status","x-uiExcelWorksheet":"Projects","x-uiExcelInclude":true},"description":{"type":"string","description":"A detailed description of the project.","x-uiFieldGroup":"Project","x-uiFilterType":"text","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"richText","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Description","x-uiIncludeInExcel":true,"x-uiExcelInclude":true,"x-uiExcelHeaderName":"Description","x-uiExcelWorksheet":"Projects"},"benefits":{"type":"string","description":"Describes the benefits offered to NASA funded and planned missions, unfunded or planned missions, commercial space industry, and to the nation.","x-uiFieldGroup":"Project","x-uiFilterType":"text","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"richText","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiName":"Benefits","x-uiExcelInclude":true,"x-uiExcelHeaderName":"Benefits","x-uiExcelWorksheet":"Projects"},"primaryImage":{"$ref":"#/components/schemas/libraryItem","type":"object","x-uiGrid-Exclude":true,"x-uiList-Include":true,"x-uiName":"Image Caption","x-uiExcelInclude":false,"x-uiFormatString":"{description}"},"program":{"$ref":"#/components/schemas/program","description":"Responsible program for this project.","x-uiCanSort":true,"x-uiFieldGroup":"Organizations and Contacts","x-uiFilterType":"checkbox","x-uiFormatString":"{title} ({acronym})","x-uiGrid-CanHide":true,"x-uiGrid-CellMinWidth":100,"x-uiGrid-CellRenderer":"renderProgram","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellWidth":100,"x-uiGrid-DefaultField":true,"x-uiGrid-FieldGroup":"Program Classification","x-uiList-Include":true,"x-uiName":"Responsible Program","x-uiExcelInclude":false},"programId":{"type":"integer","format":"int64","description":"Unique identifier for the program this project falls under.","minimum":1,"maximum":9,"x-uiGrid-Exclude":true},"responsibleMd":{"$ref":"#/components/schemas/organization","description":"The responsible Mission Directorate of the project","x-uiCanSort":true,"x-uiFieldGroup":"Organizations and Contacts","x-uiFilterType":"checkbox","x-uiGrid-CanHide":true,"x-uiGrid-CellRenderer":"renderResponsibleMd","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":250,"x-uiGrid-CellWidth":250,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Responsible Mission Directorate","x-uiExcelFormatString":"{organization_name} ({acronym})","x-uiExcelHeaderName":"Responsible Mission Directorate","x-uiExcelInclude":true,"x-uiExcelWorksheet":"Projects","x-uiFormatString":"{organization_name} ({acronym})"},"trlBegin":{"type":"integer","description":"The technology maturity (technology readiness level) of the project at its beginning.","minimum":1,"maximum":9,"x-uiFieldGroup":"Technology Classification","x-uiFilterType":"trl","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderTrl","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":100,"x-uiGrid-CellWidth":100,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Start TRL","x-uiExcelInclude":true,"x-uiExcelHeaderName":"Start TRL","x-uiExcelWorksheet":"Projects"},"trlCurrent":{"type":"integer","description":"The current technology maturity (technology readiness level) of the project.","minimum":1,"maximum":9,"x-uiFieldGroup":"Technology Classification","x-uiFilterType":"trl","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderTrl","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":100,"x-uiGrid-CellWidth":100,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Current TRL","x-uiExcelHeaderName":"Current TRL","x-uiExcelWorksheet":"Projects"},"trlEnd":{"type":"integer","description":"The estimated technology maturity (technology readiness level) of the project at its end.","minimum":1,"maximum":9,"x-uiFieldGroup":"Technology Classification","x-uiFilterType":"trl","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderTrl","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":100,"x-uiGrid-CellWidth":100,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"End TRL","x-uiExcelInclude":true,"x-uiExcelHeaderName":"End TRL","x-uiExcelWorksheet":"Projects"},"startMonth":{"type":"integer","format":"int64","description":"The start month for the project.","x-uiGrid-Exclude":true},"startYear":{"type":"integer","format":"int64","description":"The start year for the project.","x-uiGrid-Exclude":true},"endMonth":{"type":"integer","format":"int64","description":"The end month for the project.","x-uiGrid-Exclude":true},"endYear":{"type":"integer","format":"int64","description":"The end year for the project.","x-uiGrid-Exclude":true},"startDate":{"type":"string","format":"date_string","description":"The month and year the project was authorized to proceed.","x-uiFieldGroup":"Project","x-uiFilterType":"dateMonthYear","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"dateMonthYear","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":120,"x-uiGrid-CellWidth":120,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Start Date","x-uiExcelInclude":true,"x-uiExcelHeaderName":"Start Date","x-uiExcelWorksheet":"Projects","x-uiExcelType":"DATE"},"endDate":{"type":"string","format":"date_string","description":"The month and year the project is expected to complete its work.","x-uiFieldGroup":"Project","x-uiFilterType":"dateMonthYear","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"dateMonthYear","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":120,"x-uiGrid-CellWidth":120,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"End Date","x-uiExcelInclude":true,"x-uiExcelHeaderName":"End Date","x-uiExcelWorksheet":"Projects","x-uiExcelType":"DATE"},"viewCount":{"type":"integer","description":"The number of views for the project.","x-uiName":"View Count","x-uiGrid-Exclude":true,"x-uiExcelInclude":true,"x-uiExcelHeaderName":"View Count","x-uiExcelWorksheet":"Projects"},"phase":{"type":"string","description":"The project's phase (SBIR).","x-uiName":"Phase","x-uiGrid-Exclude":true,"x-uiExcelInclude":true,"x-uiExcelHeaderName":"Phase","x-uiExcelWorksheet":"Projects"},"primaryTx":{"type":"object","$ref":"#/components/schemas/projectTaxonomyNode","description":"The primary TX node that is mapped to the project.","x-uiFieldGroup":"Technology Classification","x-uiFilterType":"checkbox","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderTx","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Primary TX","x-uiExcelFormatString":"{code} {title}","x-uiExcelHeaderName":"Primary TX","x-uiExcelInclude":true,"x-uiExcelWorksheet":"Projects","x-uiExcelType":"OBJECT-SINGLE","x-uiFormatString":"{code} {title}"},"additionalTxs":{"type":"array","description":"A list of the other taxonomy areas that are mapped to this project.","items":{"$ref":"#/components/schemas/projectTaxonomyNode"},"x-uiFieldGroup":"Technology Classification","x-uiFilterType":"checkbox","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderTx","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Other TX","x-uiExcelFormatString":"{code} {title}","x-uiExcelHeaderName":"Other TX","x-uiExcelInclude":true,"x-uiExcelWorksheet":"Projects","x-uiFormatString":"{code} {title}","x-uiExcelType":"OBJECT-ARRAY"},"projectContacts":{"type":"array","description":"The contacts for this project.","items":{"$ref":"#/components/schemas/projectContact"},"x-uiFieldGroup":"Organizations and Contacts","x-uiFilterType":"projectContacts","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderProjectContact","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Project Contacts","x-uiExcelWorksheet":"Contacts","x-uiExcelInclude":true,"x-uiExcelRef":"projectContact","x-uiExcelType":"OBJECT","x-uiFormatString":"{full_name} ({project_contact_role})"},"programContacts":{"type":"array","description":"The contacts for the project's program.","items":{"$ref":"#/components/schemas/programContact"},"x-uiFieldGroup":"Organizations and Contacts","x-uiFilterType":"programContacts","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderProgramContact","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Program Contacts","x-uiExcelInclude":false,"x-uiFormatString":"{full_name} ({program_contact_role})"},"leadOrganization":{"$ref":"#/components/schemas/organization","description":"The lead organization performing work on this project.","x-uiFieldGroup":"Organizations and Contacts","x-uiFilterType":"leadOrganization","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderOrganization","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Lead Organization","x-uiExcelWorksheet":"Supporting Organizations","x-uiExcelInclude":true,"x-uiExcelRef":"organization","x-uiExcelType":"OBJECT","x-uiFormatString":"{organization_name} ({organization_type})"},"otherOrganizations":{"type":"array","description":"The organizations performing work on this project.","items":{"$ref":"#/components/schemas/organization"},"x-uiFieldGroup":"Organizations and Contacts","x-uiFilterType":"otherOrganizations","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderOrganization","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Supporting Organizations","x-uiExcelWorksheet":"Supporting Organizations","x-uiExcelInclude":true,"x-uiExcelRef":"organization","x-uiExcelType":"OBJECT","x-uiFormatString":"{organization_name} ({organization_type})"},"states":{"type":"array","description":"Locations where work is being performed on this project.","items":{"$ref":"#/components/schemas/stateTerritory"},"x-uiFieldGroup":"Project","x-uiFilterType":"checkbox","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderLocation","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Locations Where Work is Performed","x-uiExcelWorksheet":"Locations with Work","x-uiExcelInclude":true,"x-uiExcelRef":"stateTerritory","x-uiExcelType":"OBJECT","x-uiFormatString":"{name} ({abbreviation})"},"destinationTypes":{"type":"array","items":{"type":"string","enum":["Outside the Solar System","Sun","Moon and Cislunar","Mars","Others Inside the Solar System","Foundational Knowledge","Earth","Low Earth Orbit"]},"description":"Target Destinations for the project's technology.","x-uiFieldGroup":"Project","x-uiFilterType":"checkbox","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderStringList","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":230,"x-uiGrid-CellWidth":230,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Target Destinations","x-uiExcelInclude":true,"x-uiExcelHeaderName":"Target Destinations","x-uiExcelWorksheet":"Projects","x-uiExcelType":"ENUM-ARRAY"},"technologyOutcomes":{"type":"array","description":"Technology Outcome events experienced by this project.","items":{"$ref":"#/components/schemas/technologyOutcome"},"x-uiFieldGroup":"Technology Outcomes, Closeouts, and Library","x-uiFilterType":"technologyOutcomes","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderTechnologyOutcome","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiList-Include":true,"x-uiName":"Technology Outcome Events","x-uiExcelWorksheet":"Technology Outcomes","x-uiExcelInclude":true,"x-uiExcelRef":"technologyOutcome","x-uiExcelType":"OBJECT","x-uiFormatString":"{technology_outcome_date} {technology_outcome_path} - {details}"},"closeoutDocumentation":{"type":"array","description":"A document upload describing in detail the project's accomplishments, including an assessment of the final Technology Maturity (Technology Readiness Level) and other maturity measures. Represented as a library item of type 'Closeout Document' or 'Closeout Link' there can only be one per project.","items":{"$ref":"#/components/schemas/closeoutDocument"},"x-uiFieldGroup":"Technology Outcomes, Closeouts, and Library","x-uiFilterType":"text","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"renderCloseoutDocuments","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMaxWidth":400,"x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiName":"Closeout Documentation","x-uiExcelWorksheet":"Closeout Documentation","x-uiExcelInclude":true,"x-uiExcelType":"OBJECT","x-uiExcelRef":"closeoutDocument","x-uiFormatString":"{title} {url}"},"libraryItems":{"type":"array","description":"The library items attached to this project.","items":{"$ref":"#/components/schemas/libraryItem"},"x-uiFieldGroup":"Technology Outcomes, Closeouts, and Library","x-uiFilterType":"libraryItems","x-uiGrid-CanHide":true,"x-uiCanSort":false,"x-uiGrid-CellRenderer":"renderLibraryItem","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":400,"x-uiGrid-CellWidth":400,"x-uiList-Include":true,"x-uiName":"Library Items","x-uiExcelWorksheet":"Library Items","x-uiExcelInclude":true,"x-uiExcelType":"OBJECT","x-uiExcelRef":"libraryItem","x-uiFormatString":"{title}"},"lastUpdated":{"type":"string","description":"The date the project was last updated","x-uiGrid-Exclude":true},"modifiedDate":{"type":"string","format":"date_string","description":"The date on which this record was last updated.","x-uiFieldGroup":"Identification","x-uiFilterType":"dateFull","x-uiGrid-CanHide":true,"x-uiCanSort":true,"x-uiGrid-CellRenderer":"dateTime","x-uiGrid-CellTextAlign":"left","x-uiGrid-CellMinWidth":200,"x-uiGrid-CellWidth":200,"x-uiGrid-DefaultField":true,"x-uiList-Include":true,"x-uiName":"Last Modified","x-uiExcelInclude":true,"x-uiExcelHeaderName":"Last Modified","x-uiExcelWorksheet":"Projects","x-uiExcelType":"DATE"}}},"projectContact":{"type":"object","description":"Represents a contact that is linked to a project.","properties":{"contactId":{"type":"integer","format":"int64","description":"Unique ID for the contact"},"projectId":{"type":"integer","format":"int64","description":"Unique ID for the project"},"projectContactRole":{"type":"string","enum":["Primary Point of Contact","Principal Investigator","Co-Investigator","Project Manager"],"description":"Role of the contact in relation to the project.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Project Contact Role"},"fullName":{"type":"string","description":"The full name of the contact.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Contact Name"},"email":{"type":"string","description":"Email for the contact.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Email"}}},"projectTaxonomyNode":{"type":"object","description":"Represents a link between a project and a taxonomy node.","properties":{"taxonomyNodeId":{"type":"integer","format":"int64","description":"Unique ID for the taxonomy node"},"projectId":{"type":"integer","format":"int64","description":"Unique ID for the project"},"isPrimary":{"type":"boolean","description":"Whether or not the taxonomy node is the primary for the project."},"taxonomyNode":{"$ref":"#/components/schemas/taxonomyNode","description":"The taxonomy node object."}}},"schema":{"type":"object","description":"Represents the api specification schema of a particular object type.","properties":{"type":{"type":"string","description":"The data type of this schema. Usually 'object'."},"description":{"type":"string","description":"The description of this schema."},"properties":{"type":"object","description":"The properties of this schema.","additionalProperties":true}}},"searchCriteria":{"type":"object","description":"Represents search results.","properties":{"query":{"type":"string","description":"The search query string."},"sortString":{"$ref":"#/components/schemas/searchStats","description":"A sorting string. Ex. field1 asc, field2 desc"},"fetchForListView":{"type":"boolean","description":"If true, fields array is ignored and the apiSpecification controls returned fields. If false, fields array controls returned data."},"filters":{"type":"array","description":"The filters to filter against.","items":{"type":"object","$ref":"#/components/schemas/connectiveFilter"}},"fields":{"type":"array","items":{"type":"string"},"description":"The fields to return."},"limit":{"type":"integer","format":"int64","description":"The number of search results to return."},"offset":{"type":"integer","format":"int64","description":"The search results offset (zero based)."},"preFilters":{"type":"array","items":{"type":"object","$ref":"#/components/schemas/preFilters"},"description":"The pre filters to be run before performing the SOLR query. Produce a list of project IDs to filter on."},"advanced":{"type":"boolean","description":"Whether to treat the query string as a Solr query."},"getStats":{"type":"boolean","description":"Whether to return a column statistics object with the results (for example, numeric sums)."}}},"connectiveFilter":{"type":"object","description":"Contians filters as well as whether or not they should be AND or OR","properties":{"connectorOuter":{"type":"string","description":"How to pair this connective filter with others."},"connectorInner":{"type":"string","description":"How to pair the inner filters with each other."},"filters":{"type":"array","items":{"type":"object","$ref":"#/components/schemas/filter"}}}},"filter":{"type":"object","description":"The filters to filter against.","properties":{"field":{"type":"string","description":"Filter field."},"values":{"type":"array","description":"A list of values to filter on.","items":{"type":"string"}},"type":{"type":"string","description":"Determines the special type of filter this is","enum":["LESS_THAN","GREATER_THAN","LESS_THAN_EQUAL","GREATER_THAN_EQUAL","GREATER_THAN_EQUAL_LESS_THAN_EQUAL","GREATER_THAN_LESS_THAN","EXACT","OR","AND","NOT"]}}},"searchResult":{"type":"object","description":"Represents search results.","properties":{"results":{"type":"array","items":{"type":"string"},"description":"Search results that vary depending on the type of object searched."},"stats":{"$ref":"#/components/schemas/searchStats"},"suggestions":{"type":"string"},"total":{"type":"integer","format":"int64"},"limit":{"type":"integer","format":"int64"},"offset":{"type":"integer","format":"int64"},"query":{"type":"string"}}},"searchStats":{"type":"object","description":"Represents a search result.","properties":{"min":{"type":"integer","format":"int64"},"max":{"type":"integer","format":"int64"},"sum":{"type":"integer","format":"int64"},"count":{"type":"integer","format":"int64"},"countDistinct":{"type":"integer","format":"int64"},"distinctValues":{"type":"string"},"missing":{"type":"integer","format":"int64"},"mean":{"type":"integer","format":"int64"},"sumOfSquares":{"type":"integer","format":"int64"},"stdDev":{"type":"integer","format":"int64"},"cardinality":{"type":"integer","format":"int64"},"facets":{"type":"string"},"percentiles":{"type":"integer","format":"int64"}}},"selectedTabsEntry":{"type":"array","description":"Selected tabs of pages.","items":{"type":"object","properties":{"view":{"type":"string"},"section":{"type":"string"},"selectedValue":{"type":"string"}}}},"shortfall":{"type":"object","description":"Describes a shortfall object.","properties":{"shortfallId":{"type":"integer","format":"int64","description":"Unique identifier for the shortfall."},"title":{"type":"string","description":"Title of the shortfall."},"capability":{"type":"string","description":"Reference to the associated capability name."},"description":{"type":"string","description":"Description of the shortfall."}}},"stateTerritory":{"type":"object","description":"Represents a state or territory location.","properties":{"stateTerritoryId":{"type":"integer","format":"int64","description":"Unique ID for the state/territory"},"abbreviation":{"type":"string","description":"Abbreviation that can be used for the state/territory.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Abbreviation"},"name":{"type":"string","description":"Name that can be used for the state/territory.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Name"},"countryId":{"type":"integer","format":"int64","description":"Unique ID for the country where the state/territory resides."},"country":{"$ref":"#/components/schemas/country","description":"The country object."}}},"taxonomyNode":{"type":"object","description":"Represents data associated with a single taxonomy node entity.","properties":{"taxonomyNodeId":{"type":"integer","format":"int64","description":"Unique identifier for the taxonomy node"},"taxonomyRootId":{"type":"integer","format":"int64","description":"Unique identifier for the root of this taxonomy node"},"parentNodeId":{"type":"integer","format":"int64","description":"Unique identifier for the taxonomy node/root that is the direct parent of this taxonomy node"},"code":{"type":"string","description":"Code of the taxonomy node"},"title":{"type":"string","description":"Title of the taxonomy node"},"description":{"type":"string","description":"Description of the taxonomy node"},"exampleTechnologies":{"type":"string","description":"Example technologies of the taxonomy node"},"level":{"type":"integer","format":"int64","description":"The level of this node on the tree (0 being the root)"},"hasChildren":{"type":"boolean","description":"Defines whether this node has children"},"children":{"type":"array","items":{"$ref":"#/components/schemas/treeNode"}},"hasInteriorContent":{"type":"boolean","description":"Defines whether this node has interior content"}}},"taxonomyRoot":{"type":"object","description":"Represents data associated with a single taxonomy root entity.","properties":{"taxonomyRootId":{"type":"integer","format":"int64","description":"Unique ID for this taxonomy"},"releaseStatus":{"type":"integer","format":"int64","description":"ID for this taxonomy roots release status"},"title":{"type":"string","description":"Title for this taxonomy"},"description":{"type":"string","description":"Description for this taxonomy"},"releaseStatusString":{"type":"string","description":"The release status of this taxonomy"},"official":{"type":"boolean","description":"Whether or not the taxonomy root is the official NASA taxonomy"}}},"closeoutDocument":{"type":"object","description":"Represents a project's closeout document'.","properties":{"closeoutType":{"type":"string","enum":["Closeout Document","Closeout Link"],"description":"The type of the closeout documentation.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Closeout Type"},"closeoutLinkUrl":{"type":"string","description":"The url.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"URL"},"fileName":{"type":"string","description":"The file name.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"File Name"},"fileId":{"type":"integer","format":"int64","description":"The file id.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"File Download","x-uiExcelType":"FILE-ID"}}},"technologyOutcome":{"type":"object","description":"Represents a project technology outcome event.","properties":{"technologyOutcomeId":{"type":"integer","format":"int64","description":"Unique ID for the technology outcome"},"projectId":{"type":"integer","format":"int64","description":"Unique ID for the project"},"relatedProjectId":{"type":"integer","format":"int64","description":"Unique ID for the project that is related to the technology outcome if one exists."},"relatedProject":{"$ref":"#/components/schemas/project","description":"The related project object if one exists."},"technologyOutcomePath":{"type":"string","enum":["Transitioned From","Advanced From","Transitioned To","Advanced To","Infused","In-Space Demonstration","Closed Out","Canceled","Renewed","Partner Funding","Other"],"description":"Required field describing the type of technology outcome.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Outcome Path"},"technologyOutcomePartner":{"type":"string","enum":["Other NASA Program or Directorate","Other Government Agency","Industry","Academia","International Partner","Other","Leadership did not change"],"description":"More information about the technology outcome partner if one exists.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Outcome Partner"},"technologyOutcomeDate":{"type":"string","description":"Date that the technology outcome took place. This field is returned in responses in format YYYY-MM-DD (ex. 2026-02-24).","x-uiExcelInclude":"true","x-uiExcelType":"date","x-uiExcelHeaderName":"Outcome Date"},"technologyOutcomeDateString":{"type":"string","description":"Date that the technology outcome took place. Please use the following format MMM YYYY (ex. Dec 2025) when updating or creating technology outcomes."},"infusion":{"type":"string","enum":["Infused into a NASA Mission","Used in another government agency application","Used in a commercial space industry application","Used in an international partner application","Other"],"description":"If the technology outcome is infusion, more information about that technology outcome."},"technologyOutcomeRationale":{"type":"string","enum":["Budget cuts, funding reallocation, or insufficient funding","Cost overrun","Schedule overrun","No longer relevant to the mission","Merged or otherwise absorbed into another project","Other"],"description":"Reason for a canceled technology outcome."},"organizationId":{"type":"integer","format":"int64","description":"Unique ID for the organization object related to this technology outcome if one exists."},"organization":{"$ref":"#/components/schemas/organization","description":"The organization object related to this technology outcome if one exists."},"organizationName":{"type":"string","description":"The name for the organization object related to this technology outcome if one exists.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Organization Name"},"details":{"type":"string","description":"Additional details for the technology outcome.","x-uiExcelInclude":"true","x-uiExcelHeaderName":"Details"},"closeoutLinkUrl":{"type":"string","description":"Closeout link URL if one exists."},"files":{"type":"array","items":{"$ref":"#/components/schemas/technologyOutcomeFile"},"description":"Additional files related to the technology outcome, typically used by closeout technology outcomes."}}},"technologyOutcomeCriteria":{"type":"object","description":"Criteria that represents further filters for each Technology Outcome path.","properties":{"path":{"type":"string","description":"The path of the technology outcomes, represented by an enum"},"types":{"type":"array","items":{"type":"object","properties":{"type":{"type":"string","description":"Determines the special type of filter this is: PROJECT, ORGANIZATION, MISSION"},"subtypes":{"type":"array","items":{"type":"string"},"description":"A list of subtypes that further describe the Technology Outcome. Expected to be a TechnologyOutcomePartnerType enum or InfusionType enum."}}},"description":"A list of objects representing what Technology Outcome types should be filtered on."},"status":{"type":"array","items":{"type":"string"},"description":"A list of different status to filter Infused Technology Outcomes on. Can be PLANNED or OCCURRED."},"cancellations":{"type":"array","items":{"type":"string"},"description":"A list of different cancellation rationales to filter Technology Outcomes on. Can be a TechnologyOutcomeRationaleType enum."}}},"technologyOutcomeFile":{"type":"object","description":"Represents a link between a technology outcome and a file.","properties":{"technologyOutcomeId":{"type":"integer","format":"int64","description":"Unique ID for the technology outcome"},"fileId":{"type":"integer","format":"int64","description":"Unique ID for the file"},"file":{"$ref":"#/components/schemas/file","description":"The file object."},"title":{"type":"string","description":"Title to represent the technology outcome file."}}},"technologyOutcomesPreFilter":{"type":"object","description":"The pre filter built for Technology Outcome filtering.","properties":{"filter":{"type":"string","description":"The string to filter on"},"startDate":{"type":"string","description":"Start of the date range to filter on."},"endDate":{"type":"string","description":"End of the date range to filter on."},"technologyOutcomeCriteria":{"type":"array","items":{"type":"object","$ref":"#/components/schemas/technologyOutcomeCriteria"},"description":"A list of criteria that represents further filters for each Technology Outcome path."}}},"treeNode":{"type":"object","description":"Represents a taxonomy node in a tree.","properties":{"content":{"$ref":"#/components/schemas/taxonomyNode"},"children":{"type":"array","items":{"$ref":"#/components/schemas/treeNode"}}}},"uiCollapseEntry":{"type":"array","description":"Collapsed sections of pages.","items":{"type":"object","properties":{"view":{"type":"string"},"section":{"type":"string"}}}},"userSearch":{"type":"object","description":"A representation of a saved search.","properties":{"label":{"type":"string","description":"The title of the saved search."},"description":{"type":"string","description":"A description of the search."},"date":{"type":"string","description":"The date on which the saved search was created or shared."},"searchCriteria":{"type":"object","description":"The search Criteria","$ref":"#/components/schemas/searchCriteria"},"searchId":{"type":"integer","format":"int64","description":"The unique ID value of the saved search."}}}}}}